#include <windows.h>
#include <stdio.h>

extern "C" {
	__declspec(dllexport) int Func1 (void *ls);
	__declspec(dllexport) int Func2 (void *ls);
	__declspec(dllexport) int Func3 (void *ls);
}

//fes.exe񋟂֐
typedef int (*Tfes_error)(void *L,const char *errorstr);
typedef void (*Tfes_settop)(void *L,int index);
typedef int (*Tfes_isnumber)(void *L,int index);
typedef int (*Tfes_istable)(void *L,int index);
typedef int (*Tfes_isstring)(void *L,int index);
typedef int (*Tfes_isboolean)(void *L,int index);
typedef int (*Tfes_isnil)(void *L,int index);
typedef double (*Tfes_tonumber)(void *L,int index);
typedef int (*Tfes_tointeger)(void *L,int index);
typedef const char *(*Tfes_tostring)(void *L,int index);
typedef int (*Tfes_toboolean)(void *L,int index);
typedef void (*Tfes_pushnumber)(void *L,double n);
typedef void (*Tfes_pushinteger)(void *L,int n);
typedef void (*Tfes_pushstring)(void *L,const char *str);
typedef void (*Tfes_pushboolean)(void *L,int b);
typedef void (*Tfes_gettable)(void *L,int index);
typedef void (*Tfes_pop)(void *L,int index);

typedef bool (*Tfes_GetTexture)(BITMAPINFOHEADER *bmih,unsigned char **bits,const char *texname);

Tfes_error fes_error;
Tfes_settop fes_settop;
Tfes_isnumber fes_isnumber;
Tfes_istable fes_istable;
Tfes_isstring fes_isstring;
Tfes_isboolean fes_isboolean;
Tfes_isnil fes_isnil;
Tfes_tonumber fes_tonumber;
Tfes_tointeger fes_tointeger;
Tfes_tostring fes_tostring;
Tfes_toboolean fes_toboolean;
Tfes_pushnumber fes_pushnumber;
Tfes_pushinteger fes_pushinteger;
Tfes_pushstring fes_pushstring;
Tfes_pushboolean fes_pushboolean;
Tfes_gettable fes_gettable;
Tfes_pop fes_pop;
Tfes_GetTexture fes_GetTexture;

HINSTANCE fesinst=NULL;

FARPROC GPA (char *funcname);
FARPROC GPA (char *funcname) {
	FARPROC r;
	if (fesinst==NULL || (r=GetProcAddress(fesinst,funcname))==NULL) {
		printf ("DLL̃G[Ffes.exe֐%soChł܂B\n",funcname);
		system("pause");
		exit(-1);
	}
	return r;
}
BOOL APIENTRY DllMain(HANDLE hModule,DWORD ul_reason_for_call,LPVOID lpReserved);
BOOL APIENTRY DllMain(HANDLE hModule,DWORD  ul_reason_for_call,LPVOID lpReserved) {
	if (ul_reason_for_call==DLL_PROCESS_ATTACH) {
		fesinst=LoadLibrary("fes.exe");
		if (fesinst==NULL) {
			printf ("DLL̃G[Ffes.exe[hł܂B\n");
			system("pause");
			exit(-1);
		}
		fes_error=(Tfes_error)GPA("fes_error");
		fes_settop=(Tfes_settop)GPA("fes_settop");
		fes_isnumber=(Tfes_isnumber)GPA("fes_isnumber");
		fes_istable=(Tfes_istable)GPA("fes_istable");
		fes_isstring=(Tfes_isstring)GPA("fes_isstring");
		fes_isboolean=(Tfes_isboolean)GPA("fes_isboolean");
		fes_isnil=(Tfes_isnil)GPA("fes_isnil");
		fes_tonumber=(Tfes_tonumber)GPA("fes_tonumber");
		fes_tointeger=(Tfes_tointeger)GPA("fes_tointeger");
		fes_tostring=(Tfes_tostring)GPA("fes_tostring");
		fes_toboolean=(Tfes_toboolean)GPA("fes_toboolean");
		fes_pushnumber=(Tfes_pushnumber)GPA("fes_pushnumber");
		fes_pushinteger=(Tfes_pushinteger)GPA("fes_pushinteger");
		fes_pushstring=(Tfes_pushstring)GPA("fes_pushstring");
		fes_pushboolean=(Tfes_pushboolean)GPA("fes_pushboolean");
		fes_gettable=(Tfes_gettable)GPA("fes_gettable");
		fes_pop=(Tfes_pop)GPA("fes_pop");
		fes_GetTexture=(Tfes_GetTexture)GPA("fes_GetTexture");
	} else if (ul_reason_for_call==DLL_PROCESS_DETACH) {
		FreeLibrary(fesinst);
	}
	return TRUE;
}

//֐{

/*
  󂯎AbZ[W{bNXŕ\ÃoCgԂ֐łB
  ЂƂƂX^bN̎gƎv܂B
*/
int Func1 (void *L) {
	if (!fes_isstring(L,1)) {//X^bN̈`FbNB
		fes_error(L,"Func1̈ԈĂ܂BFunc1(string)");
		return 0;
	}
	const char *str=fes_tostring(L,1);//X^bN̈𕶎ɕϊ

	MessageBox(NULL,str,"DLLŕ󂯎܂",MB_OK);
	int ret=strlen(str);

	fes_settop(L,0);//߂lX^bNɐςޑOɃX^bNNAB
	fes_pushinteger(L,ret);//߂lX^bNɐςށB
	return 1;//߂l̐ԂBł͂ЂƂȂ̂łPB
}

/*
  eNX`󂯎AOf[VȂ܂܃p^[œhԂ֐łB
  DIB̎g̃TvɂȂĂ܂B
*/
int Func2 (void *L) {
	if (!fes_isstring(L,1)) {
		fes_error(L,"Func2̈ԈĂ܂BFunc2(texname)");
		return 0;
	}
	const char *texname=fes_tostring(L,1);

	BITMAPINFOHEADER bi;
	unsigned char *bits;
	if (!fes_GetTexture(&bi,&bits,texname)) {
		fes_error(L,"Func2:݂ȂeNX`w肵܂B");
		return 0;
	}
	//GetTextureԂrbg}bv́AbiHeightɂȂĂB
	//ʏDIB̓rbgf[^㉺]Ă邪AbiHeightɂȂĂ̂ŁA]ĂȂB

	int w=bi.biWidth;
	int h=-bi.biHeight;
	unsigned char *ptr=bits;
	//₷邽߂ɁAčƂĂ܂B
	for (int j=0;j<h;j++) {
		for (int i=0;i<w;i++) {
			*(ptr+3)=255;//A
			*(ptr+2)=j%255;//R
			*(ptr+1)=j%255;//G
			*(ptr)=j%255;;//B
			ptr+=4;
		}
	}

	fes_settop(L,0);//X^bNNAB
	return 0;//߂l͂Ȃ̂0B
}

